%!octave 
%
%       OS : GNU/Linux 3.9.3-1-ARCH 
% COMPILER : GNU Octave, version 3.6.4
%
%   AUTHOR : Evgeny S. Borisov
%
%  Glushkov Institute of Cybernetics
%  National Academy of Sciences of Ukraine
% 
%    http://www.mechanoid.kiev.ua
%  e-mail : nn@mechanoid.kiev.ua
% 
% $Id: build_dist_matrix.m,v 1.1 2014/02/06 12:07:56 mechanoid Exp $


% - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
% строит матрицу R расстояний между точками X
function retval = build_dist_matrix(X)
   szX = size(X,1) ;
   % матрица расстояний
   R = [] ;
   % строим треугольную матрицу R расстояний между точками из M
   for i = 1:(szX-1),
	  m = X(1,:) ; X(1,:) = [] ;
	  % дополняем столбец нулями до нужного размера вектора
	  r = [ zeros(i,1) ; dist_points(X,m) ] ;
	  R = [ R r ] ;
	  printf("%i/%i\r",i,szX);
   endfor
   R = [ R zeros(szX,1) ] ;

   % симметрично копируем 
   % нижнюю треугольную матрицу расстояний
   % в верхнюю треугольную матрицу
   R += R';

   % save('-ascii','result/R.txt','R');

   retval = R;
endfunction

